(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Models == null) {
    ELA.Models = {};
  }

  ELA.Models.BaseApp = (function(superClass) {
    extend(BaseApp, superClass);

    function BaseApp() {
      this.helpTextName = bind(this.helpTextName, this);
      this.handlePath = bind(this.handlePath, this);
      return BaseApp.__super__.constructor.apply(this, arguments);
    }

    BaseApp.prototype.hasHelpText = true;

    BaseApp.prototype.initialize = function(options) {
      if (options == null) {
        options = {};
      }
      this.parentApp = options.parentApp;
      this.on('change:path', this.handlePath);
      this.set({
        currentAside: this.get('currentAside') || null
      });
      return this.handlePath();
    };

    BaseApp.prototype.handlePath = function() {
      var first, path;
      path = this.get('path');
      this.set({
        showHelp: _.last(path) === 'help'
      });
      first = _.first(path);
      if ((first != null) && first !== 'help') {
        return this.set({
          layout: first
        });
      }
    };

    BaseApp.prototype.helpTextName = function() {
      return this.path.replace('/', '_');
    };

    BaseApp.prototype.initCurves = function(curves, options) {
      if (options == null) {
        options = {};
      }
      return this.curves = new ELA.Collections.Curves(curves, options);
    };

    BaseApp.prototype.currentApp = function() {
      return this;
    };

    BaseApp.prototype.serialize = function() {
      var curve, v;
      v = {
        parameters: _.pick(this.attributes, _.keys(this.defaults()))
      };
      if (this.curves != null) {
        v.selectedCurves = (function() {
          var i, len, ref, results;
          ref = this.curves.getHistory();
          results = [];
          for (i = 0, len = ref.length; i < len; i++) {
            curve = ref[i];
            results.push(curve.get('function'));
          }
          return results;
        }).call(this);
      }
      if (this.displayParams != null) {
        v.displayParams = this.displayParams.serialize();
      }
      if (this.get('axisLabelingForCurve') != null) {
        v.axisLabelingForCurve = this.get('axisLabelingForCurve').get('function');
      }
      return v;
    };

    BaseApp.prototype.deserialize = function(params) {
      var curve, curveFunction, i, j, len, len1, ref, ref1;
      this.set(params.parameters);
      ref = this.curves.models;
      for (i = 0, len = ref.length; i < len; i++) {
        curve = ref[i];
        curve.set({
          selected: false
        });
      }
      ref1 = this.curves.models;
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        curve = ref1[j];
        curveFunction = curve.get('function');
        if (_.contains(params.selectedCurves, curveFunction)) {
          curve.set({
            selected: true
          });
          if (curveFunction === params.axisLabelingForCurve) {
            this.set({
              axisLabelingForCurve: curve
            });
          }
        }
      }
      if (params.displayParams != null) {
        return _.defer((function(_this) {
          return function() {
            return _this.displayParams.deserialize(params.displayParams);
          };
        })(this));
      }
    };

    return BaseApp;

  })(ELA.Models.BaseAppModel);

}).call(this);
