(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Models == null) {
    ELA.Models = {};
  }

  ELA.Models.BaseSubappContainer = (function(superClass) {
    extend(BaseSubappContainer, superClass);

    function BaseSubappContainer() {
      this.handlePath = bind(this.handlePath, this);
      return BaseSubappContainer.__super__.constructor.apply(this, arguments);
    }

    BaseSubappContainer.prototype.subapps = {};

    BaseSubappContainer.prototype.initialize = function(options) {
      var AppModel, app, name, ref;
      if (options == null) {
        options = {};
      }
      this.subappInstances = {};
      ref = this.subapps;
      for (name in ref) {
        app = ref[name];
        AppModel = app.model.toFunction();
        this.subappInstances[name] = new AppModel({
          parentApp: this
        });
      }
      this.on('change:path', this.handlePath);
      return this.handlePath();
    };

    BaseSubappContainer.prototype.handlePath = function() {
      var last, path, ref, ref1, subapp, subappPath;
      path = this.get('path');
      subapp = path[0];
      if (_.isEmpty(path)) {
        subappPath = this.subappInfo()[0].path;
        ELA.router.navigate("app/" + subappPath, {
          trigger: false,
          replace: true
        });
        ref = subappPath.split('/'), last = ref[ref.length - 1];
        path.push(last);
      }
      return (ref1 = this.subappInstances[subapp]) != null ? ref1.set({
        path: path.slice(1)
      }) : void 0;
    };

    BaseSubappContainer.prototype.subappInfo = function() {
      var app, name, ref, results;
      ref = this.subappInstances;
      results = [];
      for (name in ref) {
        app = ref[name];
        results.push({
          name: app.name,
          path: app.path
        });
      }
      return results;
    };

    BaseSubappContainer.prototype.currentApp = function() {
      return this.subappInstances[this.get('path')[0]];
    };

    return BaseSubappContainer;

  })(ELA.Models.BaseAppModel);

}).call(this);
