(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Views == null) {
    ELA.Views = {};
  }

  ELA.Views.OverviewTile = (function(superClass) {
    extend(OverviewTile, superClass);

    function OverviewTile() {
      this.render = bind(this.render, this);
      this.loadApp = bind(this.loadApp, this);
      return OverviewTile.__super__.constructor.apply(this, arguments);
    }

    OverviewTile.prototype.tagName = 'li';

    OverviewTile.prototype.className = 'tile';

    OverviewTile.prototype.template = JST['overview/tile'];

    OverviewTile.prototype.events = {
      'click': 'loadApp'
    };

    OverviewTile.prototype.loadApp = function() {
      var App, ref;
      if (App = (ref = ELA[this.model.get('name').toCapitalCamel()]) != null ? ref.Models.App : void 0) {
        return ELA.router.navigate("app/" + App.prototype.path, {
          trigger: true
        });
      } else {
        return alert(t('overview.messages.not_implemented'));
      }
    };

    OverviewTile.prototype.render = function() {
      this.$el.html(this.template(this.model.toJSON()));
      return this;
    };

    return OverviewTile;

  })(Backbone.Poised.List.Item);

}).call(this);
