(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Views == null) {
    ELA.Views = {};
  }

  ELA.Views.Viewport = (function(superClass) {
    extend(Viewport, superClass);

    function Viewport() {
      return Viewport.__super__.constructor.apply(this, arguments);
    }

    Viewport.prototype.tagName = 'article';

    Viewport.prototype.className = 'viewport';

    Viewport.prototype.initialize = function(options) {
      var view;
      if (options == null) {
        options = {};
      }
      this.views = (function() {
        var i, len, ref, ref1, results;
        ref = options.views;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          view = ref[i];
          view.options = _.omit(view, 'view');
          view.options.name = view.name || Math.random().toString(36).slice(-8);
          view.View = ((ref1 = view.view) != null ? ref1.toFunction() : void 0) || ELA.Views.GraphView;
          results.push(view);
        }
        return results;
      })();
      this.subviews = {};
      this.layouts = options.layouts;
      return this.listenTo(this.model, 'change:layout', this.render);
    };

    Viewport.prototype.areaLayout = function() {
      return '"' + this.layouts[this.model.get('layout')].layout.join('" "') + '"';
    };

    Viewport.prototype._style = function() {
      return ("grid-template-areas: " + (this.areaLayout()) + ";") + 'grid-auto-columns: 1fr;' + 'grid-auto-rows: 1fr;';
    };

    Viewport.prototype.render = function() {
      var area, i, idx, j, len, len1, options, ref, ref1, ref2, view;
      ref = this.views;
      for (i = 0, len = ref.length; i < len; i++) {
        view = ref[i];
        if ((ref1 = this.subviews[view.options.name]) != null) {
          ref1.remove();
        }
      }
      this.$el.empty().attr('style', this._style());
      ref2 = this.views;
      for (idx = j = 0, len1 = ref2.length; j < len1; idx = ++j) {
        view = ref2[idx];
        area = String.fromCharCode(97 + idx);
        if (this.areaLayout().indexOf(area) > -1) {
          options = _.extend({
            model: this.model,
            parentView: this,
            localePrefix: this.localePrefix,
            attributes: {
              style: "grid-area: " + area
            }
          }, view.options);
          view = this.subviews[view.options.name] = new view.View(options);
          this.$el.append(view.render().el);
        }
      }
      return this;
    };

    return Viewport;

  })(Backbone.Poised.View);

}).call(this);
