(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Backbone.Poised.LinkedStringControl = (function(superClass) {
    extend(LinkedStringControl, superClass);

    function LinkedStringControl() {
      this.render = bind(this.render, this);
      this.initialize = bind(this.initialize, this);
      return LinkedStringControl.__super__.constructor.apply(this, arguments);
    }

    LinkedStringControl.prototype.initialize = function(options) {
      if (options == null) {
        options = {};
      }
      LinkedStringControl.__super__.initialize.apply(this, arguments);
      return this.options = _.chain(options).pick('attribute', 'rows', 'placeholder').defaults({
        type: 'text',
        placeholder: null,
        rows: 1
      }).value();
    };

    LinkedStringControl.prototype.render = function() {
      LinkedStringControl.__super__.render.apply(this, arguments);
      if (this.options.rows > 1) {
        this.subviews.textarea1 = new Backbone.Poised.Textarea(_.defaults({
          model: this.model1
        }, this.options));
        this.$control1.append(this.subviews.textarea1.render().el);
        this.subviews.textarea2 = new Backbone.Poised.Textarea(_.defaults({
          model: this.model2
        }, this.options));
        this.$control2.append(this.subviews.textarea2.render().el);
      } else {
        this.subviews.textfield1 = new Backbone.Poised.Textfield(_.defaults({
          model: this.model1
        }, this.options));
        this.$control1.append(this.subviews.textfield1.render().el);
        this.subviews.textfield2 = new Backbone.Poised.Textfield(_.defaults({
          model: this.model2
        }, this.options));
        this.$control2.append(this.subviews.textfield2.render().el);
      }
      return this;
    };

    return LinkedStringControl;

  })(Backbone.Poised.LinkedControl);

}).call(this);
