(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Backbone.Poised.RangeControl = (function(superClass) {
    extend(RangeControl, superClass);

    function RangeControl() {
      this.render = bind(this.render, this);
      this.initialize = bind(this.initialize, this);
      return RangeControl.__super__.constructor.apply(this, arguments);
    }

    RangeControl.prototype.initialize = function(options) {
      var ref, ref1, ref10, ref11, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9;
      RangeControl.__super__.initialize.apply(this, arguments);
      this.options = _.chain(this.options).pick('model', 'renderSpinner', 'clearOnFocus', 'stepSize', 'precision', 'range', 'attribute', 'unit', 'sliderMinValue', 'sliderMaxValue', 'spinnerMinValue', 'spinnerMaxValue').defaults({
        renderSpinner: true,
        clearOnFocus: true,
        type: 'number'
      }).value();
      if ((this.options.stepSize != null) && (this.options.precision == null)) {
        this.options.precision = _.find([0, 1, 2, 3], (function(_this) {
          return function(i) {
            return _this.options.stepSize * Math.pow(10, i) >= 1;
          };
        })(this));
      }
      if (this.options.renderSpinner) {
        this.spinnerOptions = _.chain(this.options).pick('model', 'attribute', 'type', 'clearOnFocus', 'unit', 'precision', 'stepSize').defaults({
          minValue: _.firstDefined(this.options.spinnerMinValue, (ref = this.options.range) != null ? ref[0] : void 0, (ref1 = this.options.range) != null ? (ref2 = ref1.spinner) != null ? ref2[0] : void 0 : void 0),
          maxValue: _.firstDefined(this.options.spinnerMaxValue, (ref3 = this.options.range) != null ? ref3[1] : void 0, (ref4 = this.options.range) != null ? (ref5 = ref4.spinner) != null ? ref5[1] : void 0 : void 0),
          parentView: this
        }).value();
      }
      return this.sliderOptions = _.chain(this.options).pick('model', 'attribute', 'stepSize').defaults({
        minValue: _.firstDefined(this.options.sliderMinValue, (ref6 = this.options.range) != null ? ref6[0] : void 0, (ref7 = this.options.range) != null ? (ref8 = ref7.slider) != null ? ref8[0] : void 0 : void 0),
        maxValue: _.firstDefined(this.options.sliderMaxValue, (ref9 = this.options.range) != null ? ref9[1] : void 0, (ref10 = this.options.range) != null ? (ref11 = ref10.slider) != null ? ref11[1] : void 0 : void 0),
        parentView: this
      }).value();
    };

    RangeControl.prototype.render = function() {
      RangeControl.__super__.render.apply(this, arguments);
      if (this.options.renderSpinner) {
        this.subviews.spinner = new Backbone.Poised.Textfield(this.spinnerOptions);
        this.$input.html(this.subviews.spinner.render().el);
      } else {
        this.subviews.value = new Backbone.Poised.Value(this.options);
        this.$input.html(this.subviews.value.render().el);
      }
      this.subviews.slider = new Backbone.Poised.Slider(this.sliderOptions);
      this.$el.append(this.subviews.slider.render().el);
      return this;
    };

    return RangeControl;

  })(Backbone.Poised.BaseControl);

}).call(this);
