(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Backbone.Poised.SubmitControl = (function(superClass) {
    extend(SubmitControl, superClass);

    function SubmitControl() {
      this.render = bind(this.render, this);
      this.resetTapped = bind(this.resetTapped, this);
      this.cancelTapped = bind(this.cancelTapped, this);
      this.submitTapped = bind(this.submitTapped, this);
      return SubmitControl.__super__.constructor.apply(this, arguments);
    }

    SubmitControl.prototype.tagName = 'ul';

    SubmitControl.prototype.className = 'poised button-group';

    SubmitControl.prototype.events = {
      'tap input.submit': 'submitTapped',
      'tap input.cancel': 'cancelTapped',
      'tap input.reset': 'resetTapped'
    };

    SubmitControl.prototype.initialize = function(options) {
      if (options == null) {
        options = {};
      }
      SubmitControl.__super__.initialize.apply(this, arguments);
      return this.options = _.chain(options).pick('cancelable', 'resetable').defaults({
        cancelable: false,
        resetable: false
      }).value();
    };

    SubmitControl.prototype.submitTapped = function(e) {
      this.trigger('submit');
      return e.preventDefault();
    };

    SubmitControl.prototype.cancelTapped = function(e) {
      this.trigger('cancel');
      return e.preventDefault();
    };

    SubmitControl.prototype.resetTapped = function(e) {
      this.trigger('reset');
      return e.preventDefault();
    };

    SubmitControl.prototype.render = function() {
      this.$el.html();
      this.$el.append('<li><input class="poised button primary submit" type="submit" value="Save"></li>');
      if (this.options.cancelable) {
        this.$el.append('<li><input class="poised button secondary cancel" type="submit" value="Cancel"></li>');
      }
      if (this.options.resetable) {
        this.$el.append('<li><input class="poised button secondary reset" type="submit" value="Reset"></li>');
      }
      return this;
    };

    return SubmitControl;

  })(Backbone.Poised.View);

}).call(this);
