(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  Backbone.Poised || (Backbone.Poised = {});

  Backbone.Poised.View = (function(superClass) {
    extend(View, superClass);

    function View(options) {
      if (options == null) {
        options = {};
      }
      this.remove = bind(this.remove, this);
      this.__arguments__ = Array.prototype.slice(arguments, 0);
      this.locale = options.locale;
      this.localePrefix = options.localePrefix;
      if ((options != null ? options.parentView : void 0) != null) {
        this.parentView = options.parentView;
      }
      View.__super__.constructor.apply(this, arguments);
      this.subviews = {};
      this.on('all', (function(_this) {
        return function() {
          if (_this.parentView != null) {
            return _this.parentView.trigger.apply(_this.parentView, arguments);
          }
        };
      })(this));
    }

    View.prototype.loadLocale = function() {
      var args, i, j, k, key, keys, len, len1, len2, locale, locales, options, prefix, ref, ref1;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      options = _.isObject(_.last(args)) ? args.pop() : {};
      keys = args;
      locales = [];
      if (_.isArray(this.locale)) {
        ref = this.locale;
        for (i = 0, len = ref.length; i < len; i++) {
          locale = ref[i];
          locales.push(locale);
        }
      }
      if (_.isString(this.locale)) {
        locales.push(this.locale);
      }
      for (j = 0, len1 = keys.length; j < len1; j++) {
        key = keys[j];
        if (_.isArray(this.localePrefix)) {
          ref1 = this.localePrefix;
          for (k = 0, len2 = ref1.length; k < len2; k++) {
            prefix = ref1[k];
            locales.push(prefix + "." + key);
          }
          locales;
        }
        if (_.isString(this.localePrefix)) {
          locales.push(this.localePrefix + "." + key);
        }
        locales.push(key);
      }
      return t.apply(null, slice.call(locales).concat([options]));
    };

    View.prototype.Present = function(model) {
      return model._presenter != null ? model._presenter : model._presenter = new (model.__proto__.Presenter || Backbone.Poised.View)({
        model: model,
        locale: this.locale,
        localePrefix: this.localePrefix
      });
    };

    View.prototype.remove = function() {
      _.invoke(this.subviews, 'remove');
      return View.__super__.remove.apply(this, arguments);
    };

    return View;

  })(Backbone.View);

}).call(this);
